local Exp_ZoneNames = {};
local Exp_Targets = {};
local lastmap="";
local showmissing = true;

local Astrolabe = DongleStub("Astrolabe-0.4");



function ExplorerCoords_OnLoad()
	ExplorerCoordsFrame:RegisterEvent("WORLD_MAP_UPDATE");


	

	Exp_ZoneNames[1] = { GetMapZones(1) } ;
	Exp_ZoneNames[2] = { GetMapZones(2) } ;
	Exp_ZoneNames[3] = { GetMapZones(3) } ;
	Exp_ZoneNames[4] = { GetMapZones(4) } ;
	for i=1,30,1 do
	  Exp_Target=CreateFrame("Button", "ExplorerCoordsWorldTargetFrame",WorldMapDetailFrame );
	  Exp_Target:SetWidth(16);
          Exp_Target:SetHeight(16);
	  Exp_Target.icon = Exp_Target:CreateTexture("ARTWORK");
          Exp_Target.icon:SetAllPoints();
	  Exp_Target.icon:SetTexture("Interface\\AddOns\\ExplorerCoords\\images\\coordicon");
	  Exp_Target:SetFrameLevel(10000);
	  Exp_Target:EnableMouse(true);
	   Exp_Target:SetScript("OnEnter", ExplorerCoords_Coord_OnEnter);
	  Exp_Target:SetScript("OnLeave", ExplorerCoords_Coord_OnLeave);
	  Exp_Targets[i]=Exp_Target;
	end

	
end

function ExplorerCoords_OnEvent()
	if ( (event == "WORLD_MAP_UPDATE") and WorldMapFrame:IsVisible() ) then
		ExplorerCoords_UpdateMap();
	end
end


function ClearNotes()
	for i=1,30,1 do
		Exp_Target = Exp_Targets[i];
		Exp_Target:Hide();
	end
end

function ExplorerCoords_UpdateMap()
	ClearNotes();
	if(GetCurrentMapZone()>0) then
	  
	  currentzone = Exp_ZoneNames[GetCurrentMapContinent()][GetCurrentMapZone()];
	  if( ExplorerCoord[currentzone]) then
	    if(lastmap==currentzone) then
		showmissing = false;
	    else
	        showmissing = true;
		lastmap = currentzone;
	    end;
	    catid = ExplorerCoord[currentzone]["catid"];
	    for i=1,GetAchievementNumCriteria(catid),1 do
	      criteriaString, criteriaType, completed, quantity, reqQuantity, charName, flags, assetID, quantityString, unknown = GetAchievementCriteriaInfo(catid, i);
	      if(completed) then
	      
	      else
		if(ExplorerCoord[currentzone][criteriaString]) then
    	          Exp_Target = Exp_Targets[i];
		  Exp_Target.id = criteriaString;
	          Exp_Target:Show();
	          coordx = ExplorerCoord[currentzone][criteriaString]["x"];
	          coordy = ExplorerCoord[currentzone][criteriaString]["y"];
	          --DEFAULT_CHAT_FRAME:AddMessage(criteriaString.."not done "..coordx.."--"..coordy);
	          Astrolabe:PlaceIconOnWorldMap( WorldMapDetailFrame, Exp_Target, GetCurrentMapContinent(), GetCurrentMapZone(), coordx, coordy );
	        else
		  if(showmissing) then
   		    DEFAULT_CHAT_FRAME:AddMessage("Explorer Coords: Missing coords for "..criteriaString);
		  end
		end
	      end
	    end
	  end
	end
	
end



function ExplorerCoords_Coord_OnEnter(frame)
  
  local tooltip = WorldMapTooltip;
  tooltip:SetOwner(this, "ANCHOR_BOTTOMLEFT")
  tooltip:ClearLines()
  tooltip:AddLine(frame.id);
  tooltip:Show();

end

function ExplorerCoords_Coord_OnLeave()
  WorldMapTooltip:Hide();
end